Draft WorkingPlaneProxy: Difference between revisions

From FreeCAD Documentation
(More details on the properties)
(More complete code)
Line 49: Line 49:


==Scripting== <!--T:5-->
==Scripting== <!--T:5-->

Working plane proxy objects can easily be created in scripts and [[macros]]:
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].

Working plane proxy objects can be used in [[macros]] and from the [[Python]] console by using the following function:
</translate>
{{Code|code=
WPProxy = makeWorkingPlaneProxy(placement)
}}
<translate>
* Creates a {{incode|WPProxy}} object from the given {{incode|placement}} which is a {{incode|FreeCAD.Placement}}.
** A placement is defined by a base point, given by its {{incode|FreeCAD.Vector}}, and a {{incode|FreeCAD.Rotation}}.

The size of the Plane Proxy can be changed by overwriting its {{incode|ViewObject.DisplaySize}} and {{incode|ViewObject.ArrowSize}} attributes, with units in millimeters.

The Plane Proxy has a "Face" object as its {{incode|Shape}} attribute. This face can be used to set the current working plane by calling its {{incode|alignToFace()}} method.


<!--T:6-->
<!--T:6-->
Line 55: Line 69:
</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD,Draft
import FreeCAD, FreeCADGui, Draft

currentWP = FreeCAD.DraftWorkingPlane
currentWP = FreeCAD.DraftWorkingPlane
Draft.makeWorkingPlaneProxy(currentWP.getPlacement())
place = currentWP.getPlacement()

WPProxy = Draft.makeWorkingPlaneProxy(place)
WPProxy.ViewObject.DisplaySize = 3000
WPProxy.ViewObject.ArrowSize = 200

YAxis = FreeCAD.Vector(0, 1, 0)
point2 = FreeCAD.Vector(3000, 0, 0)
place2 = FreeCAD.Placement(point2, FreeCAD.Rotation(YAxis, 90))

WPProxy2 = Draft.makeWorkingPlaneProxy(place2)
WPProxy2.ViewObject.DisplaySize = 3000
WPProxy2.ViewObject.ArrowSize = 200

Axis = FreeCAD.Vector(1, 1, 1)
point3 = FreeCAD.Vector(-3000, 3000, 0)
place3 = FreeCAD.Placement(point3, FreeCAD.Rotation(Axis, 90))

WPProxy3 = Draft.makeWorkingPlaneProxy(place3)
WPProxy3.ViewObject.DisplaySize = 3000
WPProxy3.ViewObject.ArrowSize = 200
FreeCAD.ActiveDocument.recompute()

currentWP.alignToFace(WPProxy3.Shape)
FreeCADGui.Snapper.setGrid()
}}
}}



Revision as of 01:01, 21 November 2018

Draft SetWorkingPlaneProxy

Menu location
Draft → Utilities → Create WP Proxy
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Draft SelectPlane

Description

This command will place a Plane Proxy object aligned to the current Working Plane.

This proxy object can be used like a face to quickly change the working plane using the Draft SelectPlane tool. The camera position and visibility property of the objects in the 3D view can be stored in the proxy object, and can be restored when using the Draft SelectPlane tool.

How to use

  1. Make sure the Working Plane is set as you want.
  2. Go to the menu Draft → Utilities → File:Draft SetWorkingPlaneProxy.png Create WP Proxy.

The working plane stored in the Proxy object can be restored by double-clicking the object in the tree view, or by selecting the Proxy object and using the Draft SelectPlane.

Notes:

  • The position of the camera is stored in the Proxy object upon creation. This position can be updated anytime by right-clicking the Proxy object in the tree view, and selecting "Write camera position".
  • The visibility state of all objects in the current document is also stored in the Proxy object upon creation. This state can be updated anytime by right-clicking the Proxy object in the tree view, and selecting "Write objects state".
  • The size and appearance of the proxy object can be set in the view properties.
  • Plane proxies can be manipulated, moved and rotated, like any other FreeCAD object, so that they are in the desired position.
  • If the RestoreView property is set to True, the camera position will also be restored to the saved position on double-clicking the Proxy object or using Draft SelectPlane
  • If the RestoreState property is set to True, the objects hidden/shown state will also be restored to the saved position on double-clicking the Proxy object or using Draft SelectPlane. If new objects have been added to the document after the state was stored in the Proxy object, the visibility of these new objects will be unchanged

Properties

Data

  • DataPlacement: specifies the position of the proxy object and the corresponding working plane.
    • DataPosition: specifies the coordinates of the proxy object.
    • DataAngle: specifies the rotation angle of the proxy object.
    • DataAxis: specifies the axis to use for the rotation angle.

View

  • ViewDisplay Size: specifies the size of the proxy object in the 3D view. If the proxy object is created in the tree view but no element is visible, increase this value until it is visible.
  • ViewArrow Size: specifies the size of the arrows indicating the three axes of the plane proxy.
  • ViewRestore View: if it is true the camera position will be restored when using the proxy with Draft SelectPlane or by double-clicking it.
  • ViewRestore State: if it is true the visibility state of all objects in the current document will be restored when using the proxy with Draft SelectPlane or by double-clicking it.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

Working plane proxy objects can be used in macros and from the Python console by using the following function:

WPProxy = makeWorkingPlaneProxy(placement)
  • Creates a WPProxy object from the given placement which is a FreeCAD.Placement.
    • A placement is defined by a base point, given by its FreeCAD.Vector, and a FreeCAD.Rotation.

The size of the Plane Proxy can be changed by overwriting its ViewObject.DisplaySize and ViewObject.ArrowSize attributes, with units in millimeters.

The Plane Proxy has a "Face" object as its Shape attribute. This face can be used to set the current working plane by calling its alignToFace() method.

Example:

import FreeCAD, FreeCADGui, Draft

currentWP = FreeCAD.DraftWorkingPlane
place = currentWP.getPlacement()

WPProxy = Draft.makeWorkingPlaneProxy(place)
WPProxy.ViewObject.DisplaySize = 3000
WPProxy.ViewObject.ArrowSize = 200

YAxis = FreeCAD.Vector(0, 1, 0)
point2 = FreeCAD.Vector(3000, 0, 0)
place2 = FreeCAD.Placement(point2, FreeCAD.Rotation(YAxis, 90))

WPProxy2 = Draft.makeWorkingPlaneProxy(place2)
WPProxy2.ViewObject.DisplaySize = 3000
WPProxy2.ViewObject.ArrowSize = 200

Axis = FreeCAD.Vector(1, 1, 1)
point3 = FreeCAD.Vector(-3000, 3000, 0)
place3 = FreeCAD.Placement(point3, FreeCAD.Rotation(Axis, 90))

WPProxy3 = Draft.makeWorkingPlaneProxy(place3)
WPProxy3.ViewObject.DisplaySize = 3000
WPProxy3.ViewObject.ArrowSize = 200
FreeCAD.ActiveDocument.recompute()

currentWP.alignToFace(WPProxy3.Shape)
FreeCADGui.Snapper.setGrid()